

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.9. grn_db &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.25.10. grn_encoding" href="grn_encoding.html" />
    <link rel="prev" title="7.25.8. grn_ctx" href="grn_ctx.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/api/grn_db.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="grn_encoding.html" title="7.25.10. grn_encoding"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="grn_ctx.html" title="7.25.8. grn_ctx"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-db">
<h1><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code><a class="headerlink" href="#grn-db" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.9.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.9.2. </span>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.9.3. </span>Reference<a class="headerlink" href="#reference" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
<dl class="c type">
<dt id="c.grn_db">
<em class="property">type </em><code class="sig-name descname">grn_db</code><a class="headerlink" href="#c.grn_db" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c type">
<dt id="c.grn_db_create_optarg">
<em class="property">type </em><code class="sig-name descname">grn_db_create_optarg</code><a class="headerlink" href="#c.grn_db_create_optarg" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>It is used for specifying options for <a class="reference internal" href="#c.grn_db_create" title="grn_db_create"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_db_create()</span></code></a>.</p>
</dd></dl>

<dl class="c member">
<dt id="c.grn_db_create_optarg.builtin_type_names">
char **<code class="sig-prename descclassname"><a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a><code class="sig-prename descclassname">.</code></code><code class="sig-name descname">builtin_type_names</code><a class="headerlink" href="#c.grn_db_create_optarg.builtin_type_names" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>組み込み型の名前となるnul終端文字列の配列を指定する。</p>
</dd></dl>

<dl class="c member">
<dt id="c.grn_db_create_optarg.n_builtin_type_names">
int <code class="sig-prename descclassname"><a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a><code class="sig-prename descclassname">.</code></code><code class="sig-name descname">n_builtin_type_names</code><a class="headerlink" href="#c.grn_db_create_optarg.n_builtin_type_names" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>n_builtin_type_namesには、optarg.builtin_type_namesで指定する文字列の数を
指定する。配列のoffsetはenum型grn_builtin_typeの値に対応する。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_create">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_db_create</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>path</em>, <a class="reference internal" href="#c.grn_db_create_optarg" title="grn_db_create_optarg">grn_db_create_optarg</a> *<em>optarg</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_create" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>新たなdbを作成します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – 初期化済みの <a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> を指定します。</p></li>
<li><p><strong>path</strong> – 作成するdbを格納するファイルパスを指定します。NULLならtemporary dbとなります。NULL以外のパスを指定した場合はpersistent dbとなります。</p></li>
<li><p><strong>optarg</strong> – <p>Currently, it is not used. It is just ignored.</p>
<p>作成するdbの組み込み型の名前を変更する時に指定します。</p>
<p>optarg.builtin_type_namesには、組み込み型の名前となるnull終端文字列の配列を指定します。optarg.n_builtin_type_namesには、optarg.builtin_type_namesで指定する文字列の数を指定します。配列のoffsetはenum型grn_builtin_typeの値に対応します。</p>
</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_open">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_db_open</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_open" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>既存のdbを開きます。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>path</strong> – 開こうとするdbを格納するファイルパスを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_touch">
void <code class="sig-name descname">grn_db_touch</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_touch" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>dbの内容の最終更新時刻を現在時刻にします。</p>
<p>最終更新時刻はキャッシュが有効かどうかの判断などに利用されます。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> – 内容が変更されたdbを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_db">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_obj_db</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_db" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objの属するdbを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_recover">
grn_rc <code class="sig-name descname">grn_db_recover</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_recover" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="admonition note">
<p class="admonition-title">Note</p>
<p>This is an experimental API.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This is a dangerous API. You must not use this API when other
thread or process opens the target database. If you use this API
against shared database, the database may be broken.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.9.</span></p>
</div>
<p>Checks the passed database and recovers it if it is broken and it
can be recovered.</p>
<p>This API uses lock existence for checking whether the database is
broken or not.</p>
<p>Here are recoverable cases:</p>
<blockquote>
<div><ul class="simple">
<li><p>Index column is broken. The index column must have source column.</p></li>
</ul>
</div></blockquote>
<p>Here are unrecoverable cases:</p>
<blockquote>
<div><ul class="simple">
<li><p>Object name management feature is broken.</p></li>
<li><p>Table is broken.</p></li>
<li><p>Data column is broken.</p></li>
</ul>
</div></blockquote>
<p>Object name management feature is used for managing table name,
column name and so on. If the feature is broken, the database can’t
be recovered. Please re-create the database from backup.</p>
<p>Table and data column can be recovered by removing an existence
lock and re-add data.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> – The database to be recovered.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on error.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_db_unmap">
grn_rc <code class="sig-name descname">grn_db_unmap</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_db_unmap" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="admonition note">
<p class="admonition-title">Note</p>
<p>This is an experimental API.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This is a thread unsafe API. You can’t touch the database while
this API is running.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.7.</span></p>
</div>
<p>Unmaps all opened tables and columns in the passed
database. Resources used by these opened tables and columns are
freed.</p>
<p>Normally, this API isn’t useless. Because resources used by opened
tables and columns are managed by OS automatically.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> – The database to be recovered.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on error.</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.9. <code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.9.1. Summary</a></li>
<li><a class="reference internal" href="#example">7.25.9.2. Example</a></li>
<li><a class="reference internal" href="#reference">7.25.9.3. Reference</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="grn_ctx.html"
                        title="previous chapter"><span class="section-number">7.25.8. </span><code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="grn_encoding.html"
                        title="next chapter"><span class="section-number">7.25.10. </span><code class="docutils literal notranslate"><span class="pre">grn_encoding</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="grn_encoding.html" title="7.25.10. grn_encoding"
             >next</a> |</li>
        <li class="right" >
          <a href="grn_ctx.html" title="7.25.8. grn_ctx"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>